scala.reflect.quasiquotes

# Holes

#### trait Holes extends AnyRef

Defines abstractions that provide support for splicing into Scala syntax.

Self Type
  Quasiquotes
Source
  Holes.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Quasiquotes
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Holes
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class ApplyHole extends Quasiquotes.Hole

2. #### abstract class Hole extends AnyRef

   Hole encapsulates information about unquotees in quasiquotes.

   Hole encapsulates information about unquotees in quasiquotes. It packs together a rank, pre-reified tree representation (possibly preprocessed) and position.

3. #### class UnapplyHole extends Quasiquotes.Hole

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Holes to any2stringadd[Holes] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Holes, B)

   Implicit information
     This member is added by an implicit conversion from Holes to ArrowAssoc[Holes] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### object Hole

7. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### def ensuring(cond: (Holes) ⇒ Boolean, msg: ⇒ Any): Holes

   Implicit information
     This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (Holes) ⇒ Boolean): Holes

    Implicit information
      This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): Holes

    Implicit information
      This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): Holes

    Implicit information
      This member is added by an implicit conversion from Holes to Ensuring[Holes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

16. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Holes to StringFormat[Holes] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

17. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

18. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

19. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

20. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

21. #### final def notify(): Unit

    Definition Classes
      AnyRef

22. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

23. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

24. #### def toString(): String

    Definition Classes
      AnyRef → Any

25. #### object unlifters

    Full support for unliftable implies that it's possible to interleave deconstruction with higher rank and unlifting of the values.

    Full support for unliftable implies that it's possible to interleave deconstruction with higher rank and unlifting of the values. In particular extraction of List[Tree] as List[T: Unliftable] requires helper extractors that would do the job: UnliftListElementwise[T]. Similarly List[List[Tree]] needs UnliftListOfListsElementwise[T].

    See also "unlift list" tests in UnapplyProps.scala

26. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

29. #### def →[B](y: B): (Holes, B)

    Implicit information
      This member is added by an implicit conversion from Holes to ArrowAssoc[Holes] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Holes to any2stringadd[Holes]

### Inherited by implicit conversion StringFormat from Holes to StringFormat[Holes]

### Inherited by implicit conversion Ensuring from Holes to Ensuring[Holes]

### Inherited by implicit conversion ArrowAssoc from Holes to ArrowAssoc[Holes]

### Ungrouped